    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * -------------------------
    028 * LegendRenderingOrder.java
    029 * -------------------------
    030 * (C) Copyright 2004-2008, by Object Refinery Limited and Contributors.
    031 *
    032 * Original Author:  Angel;
    033 * Contributor(s):   -;
    034 *
    035 * Changes
    036 * -------
    037 * 26-Mar-2004 : Version 1 (DG);
    038 *
    039 */
    040
    041package org.jfree.chart;
    042
    043import java.io.ObjectStreamException;
    044import java.io.Serializable;
    045
    046/**
    047 * Represents the order for rendering legend items.
    048 */
    049public final class LegendRenderingOrder implements Serializable {
    050
    051    /** For serialization. */
    052    private static final long serialVersionUID = -3832486612685808616L;
    053
    054    /** In order. */
    055    public static final LegendRenderingOrder STANDARD
    056            = new LegendRenderingOrder("LegendRenderingOrder.STANDARD");
    057
    058    /** In reverse order. */
    059    public static final LegendRenderingOrder REVERSE
    060            = new LegendRenderingOrder("LegendRenderingOrder.REVERSE");
    061
    062    /** The name. */
    063    private String name;
    064
    065    /**
    066     * Private constructor.
    067     *
    068     * @param name  the name.
    069     */
    070    private LegendRenderingOrder(String name) {
    071        this.name = name;
    072    }
    073
    074    /**
    075     * Returns a string representing the object.
    076     *
    077     * @return The string.
    078     */
    079    public String toString() {
    080        return this.name;
    081    }
    082
    083    /**
    084     * Returns <code>true</code> if this object is equal to the specified
    085     * object, and <code>false</code> otherwise.
    086     *
    087     * @param obj  the other object.
    088     *
    089     * @return A boolean.
    090     */
    091    public boolean equals(Object obj) {
    092        if (this == obj) {
    093            return true;
    094        }
    095        if (!(obj instanceof LegendRenderingOrder)) {
    096            return false;
    097        }
    098        LegendRenderingOrder order = (LegendRenderingOrder) obj;
    099        if (!this.name.equals(order.toString())) {
    100            return false;
    101        }
    102        return true;
    103    }
    104
    105    /**
    106     * Ensures that serialization returns the unique instances.
    107     *
    108     * @return The object.
    109     *
    110     * @throws ObjectStreamException if there is a problem.
    111     */
    112    private Object readResolve() throws ObjectStreamException {
    113        if (this.equals(LegendRenderingOrder.STANDARD)) {
    114            return LegendRenderingOrder.STANDARD;
    115        }
    116        else if (this.equals(LegendRenderingOrder.REVERSE)) {
    117            return LegendRenderingOrder.REVERSE;
    118        }
    119        return null;
    120    }
    121
    122}